
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// 各種関数
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ◆ リセット関数
function settingReset() {
	ctx1.clearRect(0,0,canvas1.width,canvas1.height);
	ctx2.clearRect(0,0,canvas1.width,canvas1.height);
	canvas2.style.cursor = 'default';
	// タイトルメニューを初期化
	for (var i = 0; i < 4; i++) hoverButton[i] = false;
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ◆ ゲームタイトル関数
function gameTitle() {
	// canvas1にタイトルを描画
	ctx1.drawImage( imageTitle, 0, 0 );
	// canvas2にボタン表示
	for (var i = 0 ; i < 4; i++) {
		ctx2.drawImage( imageButton, hoverButton[i]*160, i*40, 160, 40, 0, i*40+140, 160, 40);
	}
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ◆ 初期化関数
function startInit() {
	ctx2.clearRect(0,0,canvas1.width,canvas1.height);
	boardSize = difficult + 2;
	panelSize = 300 / boardSize;
	lastPanel = new Array(boardSize*boardSize);
	updatePanel = new Array(boardSize*boardSize);
	for (var i = 0; i < boardSize*boardSize; i++) {
		lastPanel[i] = updatePanel[i] = false;
	}
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ◆ ランダムボタン関数
function randomPush() {
	x = Math.floor(Math.random() * boardSize);
	y = Math.floor(Math.random() * boardSize);
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ◆ パネル操作関数
function panelOperation(x,y) {
	updatePanel[x + y * boardSize] = !lastPanel[x + y * boardSize];	// 選択パネルを反転
	if (y >= 1)          updatePanel[x + (y - 1) * boardSize] = !lastPanel[x + (y - 1) * boardSize];	// 上のパネルがあれば反転
	if (y < boardSize-1) updatePanel[x + (y + 1) * boardSize] = !lastPanel[x + (y + 1) * boardSize];	// 下のパネルがあれば反転
	if (x >= 1)          updatePanel[(x + y * boardSize) - 1] = !lastPanel[(x + y * boardSize) - 1];	// 左のパネルがあれば反転
	if (x < boardSize-1) updatePanel[(x + y * boardSize) + 1] = !lastPanel[(x + y * boardSize) + 1];	// 右のパネルがあれば反転
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ◆ パネル表示関数
function panelDraw() {
	// キャンバスのクリア
	ctx1.clearRect(0,0,canvas1.width,canvas1.height);
	
	// パネルを表示させる
	for (var i = 0; i < boardSize*boardSize; i++) {
		ctx1.drawImage( imagePanel, 300, !updatePanel[i]*100, imageSize, imageSize, i%boardSize*panelSize, Math.floor(i/boardSize)*panelSize, panelSize, panelSize);
		lastPanel[i] = updatePanel[i];
	}
	return;
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ◆ パネルアニメーション関数
function panelAnime() {
	// キャンバスのクリア
	ctx1.clearRect(0,0,canvas1.width,canvas1.height);
	// パネルをアニメーションさせる
	for (var i = 0; i < boardSize*boardSize; i++) {
		if (updatePanel[i] != lastPanel[i]) {
			// 操作を受けたパネルをアニメーションさせる
			ctx1.drawImage( imagePanel, animeSeq*imageSize, !updatePanel[i]*100, imageSize, imageSize, i%boardSize*panelSize, Math.floor(i/boardSize)*panelSize, panelSize, panelSize);
		} else {
			// 操作を受けていないパネルはそのまま表示させる
			ctx1.drawImage( imagePanel, 0, lastPanel[i]*imageSize, imageSize, imageSize, i%boardSize*panelSize, Math.floor(i/boardSize)*panelSize, panelSize, panelSize);
		}
	}
	if (animeSeq > 2) {
		// アニメーション完了処理
		for (var j = 0; j < boardSize*boardSize; j++) {
			lastPanel[j] = updatePanel[j];
		}
		panelAnimeEnd();
	} else {
		animeSeq += 1;
	}
	return;
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ◆ パネルアニメーション完了関数
function panelAnimeEnd() {
	if (GAME != GAME_INIT) {
		// 状態の移行
		GAME = GAME_PLAY;
		animeSeq = 0;
		// アニメーション完了時にゲームクリア判定をする
		if (checkClear()) {
			// 状態の移行
		// canvas1にタイトルを描画
			ctx1.clearRect(0,0,canvas1.width,canvas1.height);
			ctx1.drawImage( imageClear, 0, 0 );
			GAME = GAME_CLEAR;
		}
	}
	return;
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ◆ クリア判定関数
function checkClear() {
	for (var i = 0; i < boardSize*boardSize; i++) {
		// パネルが一つでも暗転していなかったらfalseを返す
		if (lastPanel[i] == false) {
			return false;
		}
	}
	ctx1.drawImage( imageTitle, 0, 0 );
	ctx2.drawImage( imageButton, 0, 220, 260, 60, 20, 220, 260, 60);
	return true;
};
